library py26;

{$mode objfpc}{$H+}

const
  Py_Eval_Input = 258;

type
  TPyObject = record
                ob_refcnt : Integer;
                ob_type : Pointer;
              end;
  PPyObject = ^TPyObject;

procedure Py_Initialize(); cdecl; external 'python26.dll';
function Py_IsInitialized() : Boolean; cdecl; external 'python26.dll';
procedure Py_Finalize(); cdecl; external 'python26.dll';
procedure PyObject_Free(obj : PPyObject); cdecl; external 'python26.dll';
function PyRun_SimpleString(code : PChar) : Integer; cdecl; external 'python26.dll';
function PyRun_String(code : PChar; start : Integer; globals : PPyObject; locals : PPyObject) : PPyObject; cdecl; external 'python26.dll';
function PyImport_AddModule(name : PChar) : PPyObject; cdecl; external 'python26.dll';
function PyModule_GetDict(module : PPyObject) : PPyObject; cdecl; external 'python26.dll';
function PyDict_GetItemString(dict : PPyObject; name : PChar) : PPyObject; cdecl; external 'python26.dll';
function PyInt_AsLong(item : PPyObject) : Integer; cdecl; external 'python26.dll';
function PyInt_FromLong(value : Integer) : PPyObject; cdecl; external 'python26.dll';
function PyString_AsString(item : PPyObject) : PChar; cdecl; external 'python26.dll';
function PyString_FromString(str : PChar) : PPyObject; cdecl; external 'python26.dll';
function PyFloat_AsDouble(item : PPyObject) : Double; cdecl; external 'python26.dll';
function PyFloat_FromDouble(value : Double) : PPyObject; cdecl; external 'python26.dll';
function PyList_GetItem(list : PPyObject; index : Integer) : PPyObject; cdecl; external 'python26.dll';
function PyList_Append(list : PPyObject; item : PPyObject) : Integer; cdecl; external 'python26.dll';
function PyList_Size(list : PPyObject) : Integer; cdecl; external 'python26.dll';

procedure PyDecRef(obj : PPyObject); stdcall;
begin
  obj^.ob_refcnt -= 1;
  if obj^.ob_refcnt = 0 then
  begin
    PyObject_Free(obj);
  end;
end;

procedure PyIncRef(obj : PPyObject); stdcall;
begin
  obj^.ob_refcnt += 1;
end;

procedure PyInitialize(); stdcall;
begin
  Py_Initialize();
end;

function PyIsInitialized() : Boolean; stdcall;
begin
  PyIsInitialized := Py_IsInitialized();
end;

procedure PyFinalize(); stdcall;
begin
  Py_Finalize();
end;

function PyMainDict() : PPyObject; stdcall;
begin
  PyMainDict := PyModule_GetDict(PyImport_AddModule('__main__'));
end;

procedure PyExecute(code : PChar); stdcall;
begin
  PyRun_SimpleString(code);
end;

function PyEvaluate(code : PChar) : PPyObject; stdcall;
begin
  PyEvaluate := PyRun_String(code, Py_Eval_Input, PyMainDict(), PyMainDict());
end;

function PyLookupDict(dict : PPyObject; name : PChar) : PPyObject; stdcall;
begin
  pyLookupDict := PyDict_GetItemString(dict, name);
end;

function PyLookupList(list : PPyObject; index : Integer) : PPyObject; stdcall;
begin
  PyLookupList := PyList_GetItem(list, index);
end;

function PyGetInt(item : PPyObject) : Integer; stdcall;
begin
  PyGetInt := PyInt_AsLong(item);
end;

function PyGetDouble(item : PPyObject) : Double; stdcall;
begin
  PyGetDouble := PyFloat_AsDouble(item);
end;

function PyGetString(item : PPyObject) : PChar; stdcall;
begin
  PyGetString := PyString_AsString(item);
end;

function PyNewInt(value : Integer) : PPyObject; stdcall;
begin
  PyNewInt := PyInt_FromLong(value);
end;

function PyNewDouble(value : Double) : PPyObject; stdcall;
begin
  PyNewDouble := PyFloat_FromDouble(value);
end;

function PyNewString(value : PChar) : PPyObject; stdcall;
begin
  PyNewString := PyString_FromString(value);
end;

procedure PyListAppend(list : PPyObject; item : PPyObject) ; stdcall;
begin
  PyList_Append(list, item);
end;

function PyListSize(list : PPyObject) : Integer; stdcall;
begin
  PyListSize := PyList_Size(list);
end;

exports
  PyInitialize,
  PyIsInitialized,
  PyFinalize,
  PyDecRef,
  PyIncRef,

  PyExecute,
  PyEvaluate,

  PyMainDict,
  PyLookupDict,
  PyLookupList,

  PyGetInt,
  PyGetDouble,
  PyGetString,

  PyNewInt,
  PyNewDouble,
  PyNewString,

  PyListAppend,
  PyListSize;

{$IFDEF WINDOWS}{$R py26.rc}{$ENDIF}

begin
end.

